# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

import bpy
from bpy.props import *
import os
import random
import mathutils
from mathutils import *


def getsizefrommesh(ob):
    bb = ob.bound_box
    return (
        bb[5][0] - bb[0][0],
        bb[3][1] - bb[0][1],
        bb[1][2] - bb[0][2])

def placeInnerPoints(mesh,count,dovoronoi,sizex,sizey,sizez):
    inv=[]
    
    for v1 in range(0,count):
        mult=2.5
           
        nx=(random.random()-0.5)*sizex*mult
        ny=(random.random()-0.5)*sizey*mult
        nz=(random.random()-0.5)*sizez*mult
        p=Vector((nx,ny,nz))

        #if dovoronoi or mesh.pointInside(point):
        #if p.magnitude<sizex:
        inv.append(p)
    
        
    return inv

class Plane():
    def __init__(self):
        self.n=Vector((0,0,0))
        self.off=Vector((0,0,0))

class face():
    def __init__(self):
        self.v=[]
        self.t=[]
        self.s=0#if face is surface
        self.dir=0#positive side iterated
        self.done=0
        self.no=Vector((1,0,0))
        self.hull=0
        
class vert():
    def __init__(self):
        self.co=Vector((0,0,0))
        self.t=[]
        self.s=0
        self.hull=0
        #self.neighbours=[]
        self.f=[]
        self.e=[]
class tetra():
    def __init__(self):
        self.v=[]
        self.f=[]
        #self.neighbours=[]
        self.midpoint=None#just for debug
        self.scenter=None#just for debug
def CalcPlaneInter(p0, p1, p2):
#Point3 *CalcPlaneInter(Plane *p0, Plane *p1,Plane *p2,Point3 *c)

# double det;
# double  a[3][3],inv[3][3];
 #Vector3 V;
 
    a=[]
    inv=[]
    for x in range(3):
        a.append([0,0,0])
        inv.append([0,0,0])     
    
    V=Vector((p0.off,p1.off,p2.off))
    
    
    a[0][0]=p0.n.x;
    a[0][1]=p0.n.y;
    a[0][2]=p0.n.z;
    
    a[1][0]=p1.n.x;
    a[1][1]=p1.n.y;
    a[1][2]=p1.n.z;
    
    a[2][0]=p2.n.x;
    a[2][1]=p2.n.y;
    a[2][2]=p2.n.z;

    det=a[0][0]*(a[1][1]*a[2][2]-a[1][2]*a[2][1])+\
      a[0][1]*(a[1][2]*a[2][0]-a[1][0]*a[2][2])+\
        a[0][2]*(a[1][0]*a[2][1]-a[1][1]*a[2][0]);

    if(det == 0):
        return None;


    inv[0][0]= a[1][1]*a[2][2]-a[1][2]*a[2][1];
    inv[0][1]= a[0][2]*a[2][1]-a[0][1]*a[2][2];
    inv[0][2]= a[0][1]*a[1][2]-a[0][2]*a[1][1];

    inv[1][0]= a[1][2]*a[2][0]-a[1][0]*a[2][2];
    inv[1][1]= a[0][0]*a[2][2]-a[0][2]*a[2][0];
    inv[1][2]= a[0][2]*a[1][0]-a[0][0]*a[1][2];

    inv[2][0]= a[1][0]*a[2][1]-a[1][1]*a[2][0];
    inv[2][1]= a[0][1]*a[2][0]-a[0][0]*a[2][1];
    inv[2][2]= a[0][0]*a[1][1]-a[0][1]*a[1][0];

    c=Vector((0,0,0));
    c.x=(inv[0][0]*V.x +inv[0][1]*V.y +inv[0][2]*V.z)/det;
    c.y=(inv[1][0]*V.x +inv[1][1]*V.y +inv[1][2]*V.z)/det;
    c.z=(inv[2][0]*V.x +inv[2][1]*V.y +inv[2][2]*V.z)/det;

    return c;


def CalcSphereCenter(v0, v1,v2, v3):
    p1=Plane()
    p2=Plane()
    p3=Plane()
    
    d1 = v0+v1
    d2 = v0+v2
    d3 = v0+v3

    d1/=2
    d2/=2
    d3/=2

    p1.n=v0-v1
    p2.n=v0-v2
    p3.n=v0-v3  

    p1.n.normalize()    
    p2.n.normalize()    
    p3.n.normalize()            
    
    p1.off = p1.n.dot(d1)
    p2.off = p2.n.dot(d2)
    p3.off = p3.n.dot(d3)       

    c=CalcPlaneInter(p1, p2, p3)
    return c;


def CalcSphereRadius(v0, v1,v2, v3):
    c=CalcSphereCenter(v0, v1,v2, v3)
    if c!=None:
        r=(v0-c).length
        return r
    else:
        return None

def SearchSmallestRadius(f,SourcePoints,IterPoints,dir):
    smallest=10000000000.0
    presult=-1;
    i=0
    cout=None
    #print 'searchsmallest'
    #print f.v
    for p in SourcePoints:
        if f.v.count(i)==0:
            dist=f.no.dot(p.co - SourcePoints[f.v[0]].co)
            #print dist
            #print 'dir and dist', dir, dist
            
            
            if (dir>0 and dist>0) or (dir<0 and dist<0):
                c=CalcSphereCenter( SourcePoints[f.v[0]].co,\
                    SourcePoints[f.v[1]].co,\
                    SourcePoints[f.v[2]].co,p.co)
                if c!=None:
                    r=(SourcePoints[f.v[0]].co-c).length
                    halfSpace=f.no.dot(c - SourcePoints[f.v[0]].co)
                    if (halfSpace>0 and dist<0) or (halfSpace<0 and dist>0):
                        r=-r
                #print r
                    if smallest>r:
                        smallest=r
                        cout=c
                        presult=(i)
        i+=1
    #print 'smallest', smallest, presult
    return presult, cout

def TriangleNormal(v1,v2,v3):
    vx=v2-v1
    vy=v3-v2
    return vx.cross(vy).normalize()

def buildFirstFace(SP):
    p1=SP[0]
    dist=1000000000000
    
    i=0
    for p2t in SP:
        if p1!=p2t:
            dn=(p2t.co-p1.co).length
            if dn<dist:
                dist=dn
                i2=i
        i+=1
    p2=SP[i2]
    e1=(p1.co-p2.co)
    minr=10000000000000
    i=0
    for p3t in SP:
        if p3t!=p1 and p3t!=p2:
            e2=p2.co-p3t.co
            e3=p3t.co-p1.co
            if e1.cross(e2).length!=0:
                r=(e1.length*e2.length*e3.length)/(2*(e1.cross(e2).length))
            if r<minr:
                #p3=p3t
                minr=r
                i3=i
        i+=1
    newface=face()
    newface.dir=1
    newface.v=[0,i2,i3]
    newface.no=TriangleNormal(SP[0].co,SP[i2].co,SP[i3].co)
    
    for vi in newface.v:
        SP[vi].f.append(newface)
    return  newface

def buildTetra(f,SP,IP,AFL,dir,newfi,fvar):
    pn,c=SearchSmallestRadius(f,SP,IP,dir)
    if pn>-1:
        newtetra=tetra()
        tetrashouldbeadded=1
        aflextend=[]
        aflremove=[]
        newtetra.v.extend((f.v[0],f.v[1],f.v[2],pn))
        newtetra.scenter=c
        newtetra.f=[f]
        for side in newfi:
            newface=face()
    
            for vi in range(3):
                newface.v.append(newtetra.v[side[vi]])#assign verts to new faces
            #newface.v.sort()
            
            inafl=0
            for f1 in SP[newface.v[0]].f:
                #print f.v,newfacv
                
                for var in fvar:
                    fmix=[f1.v[var[0]],f1.v[var[1]],f1.v[var[2]]]
                    if fmix==newface.v:
                        inafl=1
                        #replace=f1
                        newface.v=fmix
                        if f1.done==1:
                            tetrashouldbeadded=0
                        else:
                            aflremove.append(f1)
                        break;
    
            if not inafl: 
                aflextend.append(newface)
                newface.no=TriangleNormal(SP[newface.v[0]].co,SP[newface.v[1]].co,SP[newface.v[2]].co)
                newface.dir=-newface.no.dot((SP[newtetra.v[side[3]]].co - SP[newface.v[1]].co))
            
                
                
        if tetrashouldbeadded:
    
            for newface in aflextend:
                #print newface.dir
                newtetra.f.append(newface)
                for vi in newface.v:
                    #if SP[vi].f.count(newface)==0:
                    SP[vi].f.append(newface)
            #print 'AFL', AFL
            #print 'AFLREMOVE', aflremove
                
            for rf in aflremove:
                newtetra.f.append(rf)
                AFL.remove(rf)
                rf.done=1
                
            for f in newtetra.f:
                f.t.append(newtetra)
            
            AFL.extend(aflextend)
            #DF.extend(aflextend)       
            for vi in newtetra.v:
                SP[vi].t.append(newtetra)
                for vi1 in newtetra.v:
                    if vi!=vi1:
                        if SP[vi].e.count((vi,vi1))==0:
                            SP[vi].e.append((vi,vi1))
                            SP[vi1].e.append((vi1,vi))
            midpoint=(SP[newtetra.v[0]].co+SP[newtetra.v[1]].co+SP[newtetra.v[2]].co+SP[newtetra.v[3]].co)/4
            newtetra.midpoint=midpoint
                
            return newtetra
    else:
        f.hull=1
        for vi in f.v:
            SP[vi].hull=1
        return None
    
def meshVoronoi(context,p,ob):
#    maxx=-10000000
#    maxy=-10000000
#    maxz=-10000000
#    minx=10000000
#    miny=10000000
#    minz=10000000
    xs=[]
    ys=[]
    zs=[]
    for t in p.t:
        xs.append(t.scenter[0])
        ys.append(t.scenter[1])
        zs.append(t.scenter[2])
    bb = ob.bound_box
    if max(xs)<bb[0][0] or min (xs)>bb[5][0] or max(ys)<bb[0][1] or min (ys)>bb[3][1] or max(zs)<bb[0][2] or min (zs)>bb[1][2]:
        return 
        #if abs(t.scenter[0])>sizex*5 or abs(t.scenter[1])>sizey*5 or abs(t.scenter[2])>sizez*5 :
       #     return 
    if p.hull==0:
        
            
        scene = context.scene

        # Can't edit anything, unless we have an active obj.
        name='voronoi_cell'
        mesh = bpy.data.meshes.new(name)
    
    
        
        vts=[]
        i=0#temporary indices for each cell
        for t in p.t:
            vts.append(t.scenter-p.co)
            t.i=i
            i+=1
        #shm.verts.extend(vts)
        edgs=[]
        for f in p.f:
            if len(f.t)>1:
                #print f.t
                edgs.append((f.t[0].i,f.t[1].i))
        #shm.edges.extend(edgs)
        # Make a mesh from a list of verts/edges/faces.
    
        # Update mesh geometry after adding stuff.
        mesh.from_pydata(vts, edgs,[])
        #mesh.update()
    
        # Deselect all objects.
        bpy.ops.object.select_all(action='DESELECT')
    
        # Create new object
        ob_new = bpy.data.objects.new(name, mesh)
        
        # Link new object to the given scene and select it.
        scene.objects.link(ob_new)
        ob_new.selected = True
        ob_new.location = p.co
        scene.objects.active = ob_new
        if p.hull==1:
            bpy.ops.object.game_property_new()
        bpy.ops.object.editmode_toggle()
        
        bpy.ops.mesh.select_all(action='DESELECT')

        bpy.ops.object.editmode_toggle()
        faces=[]
        
        for e in p.e:
            fan=[]
            for t in p.t:
                if t.v.count(e[1])==1:
                    mesh.verts[t.i].selected=1
                    #fan.append(t.i)
            #for vi in range(1,len(fan)-2):
            #   faces.append([fan[0],fan[vi],fan[vi+1]])
                
        
            bpy.ops.object.editmode_toggle()
        
            
            bpy.ops.mesh.fill()
            bpy.ops.mesh.select_all(action='DESELECT')

            bpy.ops.object.editmode_toggle()
        
        bpy.ops.object.editmode_toggle()
        
        bpy.ops.mesh.select_all(action='SELECT')
        bpy.ops.mesh.normals_make_consistent(inside=False)

        bpy.ops.object.editmode_toggle()

        
        
        return ob_new
            
def meshTetra(mtetra,mverts):
    newob=Object.New('Mesh','tetra')
    scene.objects.link(newob)
    shm=newob.getData(0,1)
    vts=[]
    f=[]
    #print e
    for vi in mtetra.v:
        vts.append(mverts[vi].co)
    e=[0,1,2,3]
    for v in e:
        for v1 in e:
            if v1!=e:
                for v2 in e:
                    if v2!=v1!=v:
                        f.append((v,v1,v2))
    
    shm.verts.extend(vts)
    #print 'tetrapoints', mtetra.midpoint,mtetra.scenter
    shm.faces.extend(f)
    for f in shm.faces:
        v0=f.verts[0].co
        v1=f.verts[1].co
        v2=f.verts[2].co
        nostart=(v0+v1+v2)/3
        no=TriangleNormal(v0,v1,v2)
        noend=nostart+no.normalize()*0.3
        
        #shm.verts.extend((nostart,noend))  
        #shm.edges.extend((len(shm.verts)-1,len(shm.verts)-2))
    #shm.verts.extend((mtetra.midpoint,mtetra.scenter))
    recenterTetra(newob,mtetra.midpoint)
    shm.update()
    shm.sel=1
    shm.recalcNormals()
    #print mtetra.midpoint,mtetra.scenter
    addGEProperties(newob)
    return newob

def add_voronoi(context,npoints):
    scene=bpy.context.scene
    ob= bpy.context.active_object
    loc=ob.location
    #newob=Object.New('Mesh','copy')
    #scene.objects.link(newob)
    m=ob.data
    #newob.link(m)
    
    
    sizex,sizey,sizez=getsizefrommesh(ob)
    
    
    #f props.meshing_type=='VORONOI':
    dovoronoi=1
    inv=placeInnerPoints(m,npoints,dovoronoi,sizex,sizey,sizez)
    #print (inv)
    totv=len(m.verts)
    for v in m.verts:
        inv.append(v.co)
    #m.add_geometry(len(inv),0,0)
    # for i,k in enumerate(inv):
    #     m.verts[totv+i].co=k


    # inv=placeSurfacePoints(m,vertsperface)
        
    # m.verts.extend(inv)
    
    # inv= placeEdgePoints(m,vertsperedge)
    
    # m.verts.extend(inv)
    
    
    print ('start')
    SP=[]#sourcepoints, points which are present at start
    IP=[]#iterated points, just indices, the list empties through time
    i=0
    for v in inv:
        newv=vert()
        #v.co=Vector(v.co[0]+random.random(-0.1,0.1), v.co[1]+random.random(-0.1,0.1), v.co[2]+random.random(-0.1,0.1))
        newv.co=v
        #jiggle or what.
        j=0.0001
        newv.co=Vector((newv.co[0]+(random.random()-0.5)*j, newv.co[1]+(random.random()-0.5)*j, newv.co[2]+(random.random()-0.5)*j))
        
        SP.append(newv)
        IP.append(i)
        i+=1
        #print 'wtf'
        
    #triangulate original mesh  
    #m.sel=1
    #m.quadToTriangle()  
    m.update()
    
    firstface = buildFirstFace(SP)
    
    tetras=[]
    m.update()
    
    #print SP,IP
    fvar=[0,1,2],[1,2,0],[2,0,1],[0,2,1],[2,1,0],[1,0,2]
    newfi=[[1,2,3,0],[0,2,3,1],[0,1,3,2]]#indices for new faces last is always the opposite vert
    icheck=0
    AFL=[firstface]
    t1=buildTetra(firstface,SP,IP,AFL,-1,newfi,fvar)
    if t1!=None: 
        tetras.append(t1)
    
    while len(AFL)>0:#icheck< 1:#
        icheck+=1
        #print AFL
        f=AFL.pop(0)
        f.done=1
        t=buildTetra(f,SP,IP,AFL,f.dir,newfi,fvar)
        if t!=None:
            tetras.append(t)
    ng=[]
    if dovoronoi:

        for i,p in enumerate(SP):
            print('meshing voronoi cell',i)
            vorocell=meshVoronoi(context,p,ob)
            if vorocell!=None:
                vorocell.location+=loc
                ng.append(vorocell)
    else:
        for t in tetras:
                meshTetra(t,m.verts)
    #do 
    for o in ng:
        o.selected=1
    i=0
    while bpy.data.groups.get('Voronoi.'+str(i).zfill(3))!=None:
        i+=1
    bpy.ops.group.create(name="Voronoi."+str(i).zfill(3))

class AddVoronoi(bpy.types.Operator):
    '''Add a group of random voronoi tiles, with an object selected, the group will encompass it'''
    bl_idname = "object.add_voronoi"
    bl_label = "Add voronoi group"
    bl_options = {'REGISTER', 'UNDO'}

    exe = BoolProperty(name="Execute",
        description="If it shall actually run, for optimal performance...",
        default=False)
    npoints = IntProperty(name="Number of source points",
        description="Number of source points",
        min=25,max=400,
        default=120)
    '''
    meshing_type = EnumProperty(name='Meshing type',
        items=(
            ('VORONOI', 'Voronoi', 'a'),
            ('DELAUNAY', 'Delaunay', 'a')),
        description='Meshing type',
        default='VORONOI')
    '''

    def execute(self, context):
        
        #getIslands(context.object)
        props = self.properties

        if   props.exe:
            add_voronoi(context,props.npoints)

            
            
            
        return {'FINISHED'}


